/*
 * $Source: /u/pfratar/src/files-2.1/src/RCS/attributes.c,v $
 *
 * $Id: attributes.c,v 6.8 1993/03/30 22:12:20 pfratar v2_1pl10 $
 *
 * files - full screen file manager for UNIX
 * Copyright (C) 1993 Paul Frattaroli
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
#define EXTERN
#include "global.h"
#undef EXTERN

#ifndef lint
static char *rcsid = "$Id: attributes.c,v 6.8 1993/03/30 22:12:20 pfratar v2_1pl10 $";
#endif

/*
 * toggle_mode_bits() - Toggle the bit at the correct position.
 */
void
toggle_mode_bits(mode_t *m, int p)
{
    mode_t tm;

    switch(p) {
        case 0:
        case 1:
        case 3:
        case 4:
        case 6:
        case 7:
            *m ^= (1 << (8 - p));
            break;
        case 2:
            tm = ((*m & 04000) >> 10) ^ ((*m & 0100) >> 6);
            tm++;
            tm %= 4;
            *m &= 03677;
            *m |= ((tm & 02) << 10);
            *m |= ((tm & 1) << 6);
            break;
        case 5:
            tm = ((*m & 02000) >> 9) ^ ((*m & 010) >> 3);
            tm++;
            tm %= 4;
            *m &= 05767;
            *m |= ((tm & 02) << 9);
            *m |= ((tm & 1) << 3);
            break;
        case 8:
            tm = ((*m & 01000) >> 8) ^ (*m & 1);
            tm++;
            tm %= 4;
            *m &= 06776;
            *m |= ((tm & 02) << 8);
            *m |= (tm & 1);
            break;
    }
}

/*
 * change_attr() - Change the read/write/execute attributes on a file.
 */
int
change_attr(void)
{
    int position, i, escstat;
    mode_t mode;
    char *modestr;
    int chr;

    position = 0;
    escstat = 0;
    modestr = (char *)Alloc(MAXPATHLEN * sizeof(char));
    mode = (entries + *marked_list)->e_stat.st_mode;
    mod2str((entries + *marked_list)->e_stat.st_mode, modestr);
    clear_cwin();
    cwin_yxaddstr(0, 0,
        "Use: 'h' and 'l' (or cursor keys) to move left or right,");
    cwin_yxaddstr(1, 0,
        "     spacebar to toggle, enter/return to set");

    /*
     * Don't want to display the file's I_FMT character.
     */
    cwin_yxaddstr(2, 0, modestr + 1);
    cwin_move(2, position);

    mode &= 07777;
    chr = my_getch(cwin);
    if(isupper(chr) && chr < 256)
        chr = tolower(chr);
    while(!(chr == '\n' || chr == '\r')) {
        switch(chr) {
            case 'h':
            case CSR_LFT:
                position -= (position == 0) ? 0 : 1;
                break;
            case 'l':
            case CSR_RHT: /* char from escape_seq */
                position += (position == ATTRIBWIDTH - 2) ? 0 : 1;
                break;
            case ' ':
                toggle_mode_bits(&mode, position);
                mod2str(mode, modestr);
                cwin_yxaddstr(2, 0, modestr + 1);
                break;
            case '\033':
                goto leave_change_attr;
                break;
        }
        cwin_move(2, position);
        chr = my_getch(cwin);
    }
    for( i = 0; i < num_marked; i++ ) {
        if(chmod((entries + *(marked_list + i))->e_name, (mode_t)mode))
            print_error("Could not change mode:");
        restat_file((entries + *(marked_list + i)));
    }
leave_change_attr:
    Free(modestr);
    num_marked = 0;
    new_dir(".", curfilter);
    return(RCNOERR);
}

