/*
 * config.h - contains definitions which should be configured by the user.
 *
 * $Source: /u/pfratar/src/files-2.1/src/RCS/config.h,v $
 *
 * files - full screen file manager for UNIX
 * Copyright (C) 1993 Paul Frattaroli
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef __Config_h_
#define __Config_h_

/*
 * These defines will configure 'files' to your local environment.
 * See also the variables in Makefile
 */

/*
 * DEF_EDITOR: The default editor to start if EDITOR is not defined.
 * DEF_VIEWER: The default pager to use if FILESVIEWER is not defined.
 * DEF_SHELL: The default shell to use if SHELL is not defined.
 */
#define DEF_EDITOR "vi"
#define DEF_VIEWER "more -c"
#define DEF_SHELL "csh"

/*
 * Various defines for the help system.
 * FILES will use a "gopher" based help system if GOPHER_HELP is defined.
 */
/*
 * Define GOPHER_HELP if you want to use the gopher help system.
 * Define GOPHER_PATH to the initial path for the gopher based
 *   documentation.  You probably shouldn`t change this unless you have the
 *   docs on a local gopher server.  [fpg.uwaterloo.ca -> 129.97.108.41]
 * Define GOPHER_CLIENT to the path of your site's gopher client.
 * Define FILES_LIB_DIR to the path where files can find its standard help
 *   files.  These help files are only used if GOPHER_HELP is not defined.
 */
/* #define GOPHER_HELP */
#define GOPHER_PATH "-p \"Software Documentation\"/files fpg.uwaterloo.ca"
#define GOPHER_CLIENT "/software/gopher/bin/gopher"
#define FILES_LIB_DIR "/software/files/lib"
#define HELPFILE "files.help"
#define INDEXFILE "files.index"

/*
 * Paths to various executibles
 */
#ifdef MIPS
#define PATH_CP		"/bsd43/bin/cp"
#else
#define PATH_CP		"/bin/cp"
#endif
#define PATH_MV		"/bin/mv"
#define PATH_GREP	"grep"
#define PATH_RM		"/bin/rm"

#endif /* #ifndef __Config_h__ */

