/*
 * $Source: /u/pfratar/src/files-2.1/src/RCS/helpsys.c,v $
 *
 * $Id: helpsys.c,v 6.9 1993/04/14 19:23:53 pfratar v2_1pl10 $
 *
 * files - full screen file manager for UNIX
 * Copyright (C) 1993 Paul Frattaroli
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include <stdio.h>
#define EXTERN
#include "global.h"
#undef EXTERN

#ifndef lint
static char *rcsid = "$Id: helpsys.c,v 6.9 1993/04/14 19:23:53 pfratar v2_1pl10 $";
#endif

#define NUM_IDHELPLINES 11

char id_lines[NUM_IDHELPLINES][75] = {
    "Use the normal navigation keys to move to the destination directory.",
    "",
    "If you DO NOT wish to change the name of the source:",
    "  Press 'd' to complete the [c]opy or [r]ename once you reach the",
    "  destination directory.",
    "",
    "If you wish to change the name of the source:",
    "  Press 'n' and type the new name once you reach the destination",
    "  directory.",
    "",
    "Press 'a' to abort the [c]opy/[r]ename at any time."
};

/*
 * help_sys() - Start files's help system.
 */
int
help_sys(void)
{
    FILE *fp, *ifp;
    char hfn[MAXPATHLEN], ifn[MAXPATHLEN], line[MAXPATHLEN];
    int cc, index, tind, ypos, FOUND;
    long toff;
    char *p;

    sprintf(hfn, "%s/%s", FILES_LIB_DIR, HELPFILE);
    sprintf(ifn, "%s/%s", FILES_LIB_DIR, INDEXFILE);

    if((fp = fopen(hfn, "r")) == NULL) {
        warn_user("Could not open help file");
        goto __help_exit;
    }
    if((ifp = fopen(ifn, "r")) == NULL) {
        warn_user("Could not open index file");
        goto __help_exit;
    }

    clear_fwin();
    clear_cwin();

    sprintf(line, "Paul's File Manager: %s.  Version: %s  Patchlevel: %s",
            progname, VERSION, PATCHLEVEL);
    fwin_yxaddstr(3, 2, line);
    fwin_yxaddstr(4, 2, copyright);
    fwin_yxaddstr(6, 2,
        "This program comes with ABSOLUTELY NO WARRANTY");
    fwin_yxaddstr(7, 2,
        "This is free software, and you are welcome to redistribute it");
    fwin_yxaddstr(8, 2,
        "under certain conditions.  See the file COPYING for more details");

    cwin_yxaddstr(0, 0, "Press the key you want help on. ('h' to exit help)");

    do {
        cc = my_getch(fwin);
        FOUND = FALSE;
        if(cc != 'h') {
            index = (int)cc;
            while(fgets(line, sizeof line, ifp) && !FOUND) {
                p = line;
                line[strlen(line) - 1] = '\0';

                while(*p && *p != ':') p++;
                *p = '\0';
                tind = atoi(line);
                if(tind == index) {
                    toff = atol(p+1);
                    FOUND = TRUE;
                }
            }

            ypos = 0;
            clear_fwin();
            if(FOUND) {
                fseek(fp, toff, 0);
                while(fgets(line, sizeof line, fp) && strncmp(line, "@@", 2)) {
                    fwin_yxaddstr(++ypos, 0, line);
                    if(ypos >= fwinlines - 3) {
                        ypos++;
                        fwin_yxaddstr(++ypos, 0,
                                "... More: press enter/return  ...");
                        fwin_wait();
                        clear_fwin();
                        ypos = 0;
                    }
                }
            } else {
                fwin_yxaddstr(++ypos, 0, "No help found on that key");
            }
            rewind(ifp);
        }
    } while(cc != 'h');

    fclose(fp);
    fclose(ifp);

__help_exit:
    new_dir(".", curfilter);
    return(RCNOERR);
}

/*
 * interdest_help() - Give help on interactive destination choosing.
 */
int
interdest_help(void)
{
    int ypos;

    clear_fwin();
    for(ypos = 0; ypos < NUM_IDHELPLINES; ypos++) {
        fwin_yxaddstr(ypos, 0, id_lines[ypos]);
    }
    fwin_yxaddstr(++ypos, 0, ENTRET_PROMPT);
    fwin_wait();
    new_dir(".", curfilter);
    return(RCNOERR);
}

