/*
 * $Source: /u/pfratar/src/files-2.1/src/RCS/mark.c,v $
 *
 * $Id: mark.c,v 6.8 1993/03/30 22:12:20 pfratar v2_1pl10 $
 *
 * files - full screen file manager for UNIX
 * Copyright (C) 1993 Paul Frattaroli
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
#define EXTERN
#include "global.h"
#undef EXTERN

#ifndef lint
static char *rcsid = "$Id: mark.c,v 6.8 1993/03/30 22:12:20 pfratar v2_1pl10 $";
#endif

/*
 * include_files() - Include or exclude files from marked list by wildcard
 *                   match on name.
 */
int
include_files(void)
{
    FILE *pr;
    char str[MAXPATHLEN], cmd[MAXPATHLEN];
    int chr, i, INC = 0, j, tmpfd;

    clear_cwin();
    str[0] = '\0';
    chr = get_char_ans("Choose: [i]nclude, [e]xclude, [s]elect or [u]nselect ");
    switch(chr) {
        case 'i':
            INC = 1;
        case 'e':
            get_user_input("Enter wildcard expression:", str);
            if(!*str)
                break;
            sprintf(cmd, "ls -1ad %s | uniq", str);
            i = 0;

            /*
             * In order for the next part to work we have to sort by name.
             */
            if(sort_type != SBYNAME) {
                qsort(entries, count, sizeof(struct entry), fl_name_sort);
                warn_user("Warning: I have to sort by name to do this...");
                sort_type = SBYNAME;
            }

            tmpfd = dup(2);
            freopen("/dev/null", "w", stderr);
            pr = popen(cmd, "r");
            while(fgets(str, MAXPATHLEN, pr)) {
                *(str + strlen(str) - 1) = '\0';
                while(strcmp(str, (entries + i)->e_name)) {
                    if(!INC) {
                        if(marked(i) == -1) {
                            *(marked_list + num_marked) = i;
                            num_marked++;
                        }
                    }
                    i++;
                }
                if(INC) {
                    if(marked(i) == -1) {
                        *(marked_list + num_marked) = i;
                        num_marked++;
                    }
                } else {
                    if((j = marked(i)) != -1) {
                        remove_mark(j);
                    }
                }
                i++;
            }

            /*
             * If we are excluding files, we have to mark the files from the
             * last match to the end.
             */
            if(i < count && !INC) {
                for(; i < count; i++) {
                    *(marked_list + num_marked) = i;
                    num_marked++;
                }
            }
            pclose(pr);
            fclose(stderr);
            dup2(tmpfd, 2);
            fdopen(2, "w");
            close(tmpfd);
            break;
        case 's':
            for( i = 0; i < count; i++ )
                *(marked_list + i) = i;
            num_marked = count;
            break;
        case 'u':
            num_marked = 0;
            break;
        default:
            break;
    }
    new_dir(".", curfilter);
    return(RCNOERR);
}
