/*
 * mywaddstr and mymvwaddstr - Implement special highlighting and attributes
 *                             using \c type codes.
 *
 * $Source: /u/pfratar/src/files-2.1/src/RCS/myaddstr.c,v $
 *
 * files - full screen file manager for UNIX
 * Copyright (C) 1993 Paul Frattaroli
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include <curses.h>

#ifndef lint
static char *rcsid = "$Id: myaddstr.c,v 6.8 1993/03/30 22:12:20 pfratar v2_1pl10 $";
#endif

int highlight;

/*
 * mywaddstr() - Adds strings to a curses window.  Special codes are
 *               expanded into highlighting of some sort.
 */
void
mywaddstr(WINDOW *w, char *s)
{
    char *p, *q, tmp[1024];
    int BOLDON = FALSE;

    strcpy(tmp, s);
    q = p = tmp;
    while(*p) {
        switch(*p) {
            case '\\':
                *p = '\0';
                switch(*++p) {
                    case 'H':
                        waddstr(w, q);
                        wrefresh(w);
#ifndef AIX
                        if(MD) fputs(MD, stdout);
                        wrefresh(w);
#endif
                        BOLDON = TRUE;
                        break;
                    case 'h':
                        waddstr(w, q);
                        wrefresh(w);
#ifndef AIX
                        if(ME) fputs(ME, stdout);
                        wrefresh(w);
#endif
                        BOLDON = FALSE;
                        break;
                    case '\\':
                        waddstr(w, "\\");
                        wrefresh(w);
                        break;
                    default:
                        break;
                }
                q = p + 1;
                break;
            default:
                break;
        }
        p++;
    }
    waddstr(w, q);
    wrefresh(w);
}

/*
 * mymvwaddstr() - A mvwaddstr replacement.  Uses mywaddstr() above.
 */
void
mymvwaddstr(WINDOW *w, int y, int x, char *s)
{
    wmove(w, y, x);
    mywaddstr(w, s);
}

