/*
 * $Source: /u/pfratar/src/files-2.1/src/RCS/ops.c,v $
 *
 * $Id: ops.c,v 6.11 1993/03/30 22:12:20 pfratar v2_1pl10 $
 *
 * files - full screen file manager for UNIX
 * Copyright (C) 1993 Paul Frattaroli
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
#define EXTERN
#include "global.h"
#undef EXTERN

#ifndef lint
static char *rcsid = "$Id: ops.c,v 6.11 1993/03/30 22:12:20 pfratar v2_1pl10 $";
#endif

/*
 * do_command() - Actually perform the specified command.
 */
int
do_command(int cha)
{
    int rc;

    rc = 0;
    if(!num_marked) {
        NONE_MARKED = 1;
        num_marked = 1;
        *(marked_list + 0) = (fl_first + cursor_pos);
    }
    switch(cha) {
        case '\011':   /* ^I */
            if(menu_num == MENUDES) break;
            if(NONE_MARKED) {
                NONE_MARKED = 0;
                num_marked = 0;
            }
            rc = include_files();
            break;
        case '\026':   /* ^V */
            rc = new_path();
            break;
        case '\r':
        case '\n':
        case CSR_RHT:
            if(TST_FLG((entries + fl_first + cursor_pos)->e_flags, EMP_DIR))
                break;
            rc = show_file_dir();
            break;
        case '!':
            rc = goto_shell();
            break;
        case 'a':
            if(menu_num == MENUDES) {
                /* Will just setting menu_num back to MENUSTD be enough */
                menu_num = MENUSTD;
                new_dir(copy_dir, curfilter);
                CLR_FLG(dirinfo[dirindex].d_flags, SAV_DIR);
                break;
            }
            if(TST_FLG((entries + fl_first + cursor_pos)->e_flags, EMP_DIR))
                break;
            if(menu_num != MENUEXT)
                rc = change_attr();
            break;
        case 'b':
            if(menu_num == MENUDES) break;
            if(TST_FLG((entries + fl_first + cursor_pos)->e_flags, EMP_DIR))
                break;
            if(menu_num == MENUEXT)
                rc = backup_file();
            break;
        case 'c':
            if(menu_num == MENUDES) break;
            if(menu_num == MENUSTD || menu_num == MENUMUL) {
                if(TST_FLG((entries + fl_first + cursor_pos)->e_flags, EMP_DIR))
                    break;
                rc = copy_file(0, 0);
            }
            if(menu_num == MENUEXT)
                rc = configure_files();
            break;
        case 'd':
            if(menu_num == MENUDES) {
                rc = (copy_cmd) ? copy_file(0, 1) : rename_file(0, 1);
            } else if(menu_num != MENUEXT) {
                if(TST_FLG((entries + fl_first + cursor_pos)->e_flags, EMP_DIR))
                    break;
                rc = delete_file();
            } else {
                rc = define_macro();
            }
            break;
        case 'e':
            if(menu_num == MENUDES) break;
            if(TST_FLG((entries + fl_first + cursor_pos)->e_flags, EMP_DIR))
                break;
            if(menu_num == MENUSTD || menu_num == MENUMUL)
                rc = edit_file();
            break;
        case 'f':
            if(menu_num == MENUDES) break;
            if(menu_num == MENUEXT)
                rc = filter_files();
            break;
        case 'g':
            if(menu_num == MENUDES) break;
            if(TST_FLG((entries + fl_first + cursor_pos)->e_flags, EMP_DIR))
                break;
            if(menu_num == MENUEXT)
                rc = grep_file();
            break;
        case 'h':
            rc = (menu_num == MENUDES) ? interdest_help() : help_sys();
            break;
        case 'i':
            if(menu_num == MENUDES) break;
            if(menu_num == MENUSTD) {
                if(TST_FLG((entries + fl_first + cursor_pos)->e_flags, EMP_DIR))
                    break;
                rc = file_info();
            }
            if(menu_num == MENUMUL)
                rc = include_files();
            break;
        case 'm':
            if(menu_num == MENUDES) break;
            if(menu_num != MENUMUL)
                rc = menu_switch();
            break;
        case 'n':
            if(menu_num == MENUSTD)
                rc = create_file_dir();
            if(menu_num == MENUDES)
                rc = (copy_cmd) ? copy_file(1, 1) : rename_file(1, 1);
            break;
        case 'o':
            if(menu_num == MENUDES) break;
            if(menu_num != MENUEXT)
                rc = user_cmd();
            break;
        case 'p':
            if(menu_num == MENUDES) break;
            if(menu_num != MENUEXT)
                rc = print_file();
            break;
        case 'q':
            if(menu_num == MENUDES) break;
            rc = quit_prog();
            break;
        case 'r':
            if(menu_num == MENUDES) break;
            if(TST_FLG((entries + fl_first + cursor_pos)->e_flags, EMP_DIR))
                break;
            if(menu_num != MENUEXT)
                rc = rename_file(0, 0);
            break;
        case 's':
            if(menu_num == MENUDES) break;
            if(TST_FLG((entries + fl_first + cursor_pos)->e_flags, EMP_DIR))
                break;
            if(menu_num == MENUSTD)
                rc = sort_display();
            break;
        case 'v':
            if(menu_num == MENUDES) break;
            if(menu_num == MENUEXT)
                rc = show_version();
            break;
        case 'y':
            if(menu_num == MENUDES) break;
            if(menu_num != MENUEXT)
                rc = your_cmd();
            break;
        default:
            if(config_table[CT_BEEP].ct_val)
                putchar('\007');
            rc = RCNOCMD;
    }
    if(NONE_MARKED) {
        num_marked = 0;
        NONE_MARKED = 0;
    }
    return(rc);
}

/*
 * menu_switch() - Toggle between the main and extended menus.
 */
int
menu_switch(void)
{
    if(menu_num == MENUSTD)
        menu_num = MENUEXT;
    else
       menu_num = MENUSTD;
    init_cwin();
    return(RCNOERR);
}

/*
 * quit_prog() - Quit from files and return to shell.
 */
int
quit_prog(void)
{
    if(config_table[CT_QUIT].ct_val) {
        if(!ask_user("Quit FILES? (y/n) ", 'y'))
            return(RCNOERR);
    }
    return(RCQUIT);
}

/*
 * show_version() - Show files's current version info.
 */
int
show_version(void)
{
    display_version();
    new_dir(".", curfilter);
    return(RCNOERR);
}

