/*
 * $Source: /u/pfratar/src/files-2.1/src/RCS/paths.c,v $
 *
 * $Id: paths.c,v 6.8 1993/03/30 22:12:20 pfratar v2_1pl10 $
 *
 * files - full screen file manager for UNIX
 * Copyright (C) 1993 Paul Frattaroli
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
#define EXTERN
#include "global.h"
#undef EXTERN

#ifndef lint
static char *rcsid = "$Id: paths.c,v 6.8 1993/03/30 22:12:20 pfratar v2_1pl10 $";
#endif

/*
 * expand_dir() - expand normal shell special characters into paths.
 *                Example: ~ or ~joeblo
 */
char *
expand_dir(char *dir)
{
    static char tmp[MAXPATHLEN];
    char *p, *q, *r, *u;
    int was_slash = FALSE;
    struct passwd *pwtmp;

    p = dir;
    q = tmp;
    switch(*p) {
        case '~':
            p++;
            for(u = p; *u && *u != '/'; u++);
            if(*u == '/') was_slash = TRUE;
            *u = '\0';
            if(*p) {
                if((pwtmp = getpwnam(p)) != NULL)
                    r = pwtmp->pw_dir;
                else
                    return((char *)NULL);
            } else {
                r = homedir;
            }
            while(*r) *q++ = *r++;
            *q++ = '/';
            if(was_slash)
                p = u + 1;
            else
                p = u;
            break;
        default:
            break;
    }
    while(*q++ = *p++);
    return(tmp);
}

/*
 * new_path() - Prompt user for a new absolute or relative path and
 *              chdir() there.
 */
int
new_path(void)
{
    static char np[MAXPATHLEN];

    get_user_input("Enter new path (Press ^R to retrieve last):", np);
    if(*np) {
        strcpy(cur_wd, "Reading new directory...");
        display_cwd();
        refresh_cwin();
        new_dir(expand_dir(np), curfilter);
    } else
        new_dir(".", curfilter);
    return(RCNOERR);
}

