/* attributes.c */
void toggle_mode_bits(mode_t *m, int p);
int change_attr(void);
/* configure.c */
int configure_files(void);
int read_configuration(void);
int write_configuration(void);
/* dir.c */
void read_cur_dir(char *filt);
int check_dirperms(char *path);
void new_dir(char *path, char *filt);
int check_dirinfo(char *filt);
void save_old_dir(struct dirst *dip);
void free_old_dir(struct dirst *dip);
void restat_file(struct entry *fep);
void free_all_info(void);
void waitkey(void);
void get_home_directory(void);
/* display.c */
void init_screen(void);
void end_screen(void);
void start_win(void);
void refresh_screen(void);
void refresh_fwin(void);
void refresh_cwin(void);
void init_cwin(void);
void display_cwd(void);
void fix_cwd(char *p);
void init_keywin(void);
void update_keywin(void);
void repaint_screen(void);
void page_up(void);
void page_down(void);
void scroll_up(void);
void scroll_down(void);
int cursor_up(int current, int beep);
int cursor_down(int current, int beep);
void go_top(void);
void go_end(void);
void display_fwin(void);
void display_marks(void);
void warn_user(char *warn);
void clear_cwin(void);
void clear_fwin(void);
int ask_user(char *ques, char def);
int get_char_ans(char *ques);
void get_user_input(char *ques, char *ans);
void mygetstr(struct _win_st *ww, char *str);
void place_mark(void);
void remove_mark(int which);
void set_menu(void);
void display_version(void);
void cwin_yxaddstr(int y, int x, char *str);
void cwin_move(int y, int x);
void fwin_yxaddstr(int y, int x, char *str);
void fwin_wait(void);
void display_file_info(char *fn, char *o, char *g, ino_t inod, nlink_t numl, char *atm, char *ctm);
void calc_fmt_strings(void);
void window_change_size(void);
int my_getch(struct _win_st *w);
int escape_seq(int *status, int chr);
void set_isig(void);
void init_syswin(void);
void end_syswin(void);
void syswin_addstr(char *str);
void syswin_msg(char *warn);
void syswin_wait(void);
/* fileops.c */
int backup_file(void);
int copy_file(int newnm, int indest);
int create_file_dir(void);
int delete_file(void);
int edit_file(void);
int filter_files(void);
int grep_file(void);
int file_info(void);
int rename_file(int newnm, int indest);
/* helpsys.c */
int help_sys(void);
int interdest_help(void);
/* macro.c */
void read_a_file(char *fn, char **l, int *nm);
void read_startup_files(void);
void write_a_file(char *fn, char **l, int nlm);
void write_startup_file(void);
int valid_cmd_string(char *test);
void preproc_cmd(char *cmd);
int expand_cmd(char *cmd, struct entry *eptr);
char *fix_file_name(char *fn);
int define_macro(void);
void execute_macro(char **mpl, int nmp);
int print_file(void);
int your_cmd(void);
/* main.c */
int main(int argc, char *argv[]);
void exit_program(void);
void tm2str(struct tm *tt, char *tstr);
void mod2str(mode_t m, char *mstr);
void fl_str(struct entry *ep);
void fixname(char *orig, char *new);
void set_fl_indices(int newfl_first, int warp);
void *Alloc(int size);
void *RealFree(void *to_free);
void my_system(char *cmd, int pause);
int check_recursive_cp(char *a, char *b);
void setup_stderr(void);
void undo_stderr(void);
void pass_signal(int s);
void syswin_system(char *bin, char *swch, char *f2);
void get_error_str(int status);
void print_error(char *basemsg);
int marked(int which);
void sort_marked_list(void);
int intp_cmp(int *a, int *b);
void handle_sigsegv(void);
char *basename(char *fullname);
/* mark.c */
int include_files(void);
/* myaddstr.c */
void mywaddstr(struct _win_st *w, char *s);
void mymvwaddstr(struct _win_st *w, int y, int x, char *s);
/* ops.c */
int do_command(int cha);
int menu_switch(void);
int quit_prog(void);
int show_version(void);
/* paths.c */
char *expand_dir(char *dir);
int new_path(void);
/* shells.c */
int goto_shell(void);
int user_cmd(void);
/* show.c */
void view_file(char *fname);
int show_file_dir(void);
/* sorting.c */
int fl_extn_sort(struct entry *e1, struct entry *e2);
int fl_time_sort(struct entry *e1, struct entry *e2);
int time_t_cmp(time_t a, time_t b);
int fl_size_sort(struct entry *e1, struct entry *e2);
int off_t_cmp(off_t a, off_t b);
int fl_name_sort(struct entry *e1, struct entry *e2);
int fl_def_sort(struct entry *e1, struct entry *e2);
int sort_display(void);
