/*
 * $Source: /u/pfratar/src/files-2.1/src/RCS/shells.c,v $
 *
 * $Id: shells.c,v 6.9 1993/03/30 22:12:20 pfratar v2_1pl10 $
 *
 * files - full screen file manager for UNIX
 * Copyright (C) 1993 Paul Frattaroli
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
#define EXTERN
#include "global.h"
#undef EXTERN

#ifndef lint
static char *rcsid = "$Id: shells.c,v 6.9 1993/03/30 22:12:20 pfratar v2_1pl10 $";
#endif

/*
 * goto_shell() - Start an interactive shell.
 */
int
goto_shell(void)
{
    char shell[MAXPATHLEN], *tmp;

    end_screen();
    tmp = getenv("SHELL"); 
    if(tmp) {
        strcpy(shell, tmp);
        my_system(shell, NOPAUSE);
    } else
        my_system(DEF_SHELL, NOPAUSE);
    num_marked = 0;
    start_win();
    new_dir(".", curfilter);
    return(RCNOERR);
}

/*
 * user_cmd() - Escape to the shell for a command.
 */
int
user_cmd(void)
{
    static char ocmd[MAXPATHLEN];
    char cmd[MAXPATHLEN];
    int i;

    get_user_input("Enter command (Press ^R to retrieve last command):", ocmd);
    if(*ocmd) {
        end_screen();
        for(i = 0; i < num_marked; i++) {
            strcpy(cmd, ocmd);
            preproc_cmd(cmd);
            expand_cmd(cmd, (entries + *(marked_list + i)));
            if(cmd[0]) {
                if( i == num_marked - 1 || num_marked == 0 )
                    my_system(cmd, PAUSE);
                else
                    my_system(cmd, NOPAUSE);
            } else {
                fprintf(stderr, "Command line too long\n");
                waitkey();
            }
            restat_file((entries + *(marked_list + i)));
        }
        num_marked = 0;
        start_win();
    }
    num_marked = 0;
    new_dir(".", curfilter);
    return(RCNOERR);
}
