/*
 * $Source: /u/pfratar/src/files-2.1/src/RCS/show.c,v $
 *
 * $Id: show.c,v 6.9 1993/03/30 22:12:20 pfratar v2_1pl10 $
 *
 * files - full screen file manager for UNIX
 * Copyright (C) 1993 Paul Frattaroli
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
#define EXTERN
#include "global.h"
#undef EXTERN

#ifndef lint
static char *rcsid = "$Id: show.c,v 6.9 1993/03/30 22:12:20 pfratar v2_1pl10 $";
#endif

/*
 * view_file() - View the file using the user's file viewer or
 *               DEF_VIEWER if one isn't defined.
 */
void
view_file(char *fname)
{
    char cmd[MAXPATHLEN], viewer[MAXPATHLEN], *tmp;

    tmp = getenv("FILESVIEWER");
    if(tmp) {
        strcpy(viewer, tmp);
        sprintf(cmd, "%s '%s'", viewer, fix_file_name(fname));
    } else
        sprintf(cmd, "%s '%s'", DEF_VIEWER, fix_file_name(fname));
    end_screen();
    my_system(cmd, PAUSE);
    num_marked = 0;
    start_win();
}

/*
 * show_file_dir() - Change to a new directory to display or show a file
 *                   using view/more.
 */
int
show_file_dir(void)
{
    mode_t x;
    struct stat *tmpst;
    char cmd[MAXPATHLEN], args[MAXPATHLEN];

    x = (entries + (fl_first + cursor_pos))->e_stat.st_mode;
    x &= 0170000;
    x >>= 12;
    if(x == 012) {
        tmpst = (struct stat *)Alloc(sizeof(struct stat));
        stat((entries + fl_first + cursor_pos)->e_name, tmpst);
        x = tmpst->st_mode;
        x &= 0170000;
        x >>= 12;
        Free(tmpst);
    }
    if(x == 004) {
        strcpy(cur_wd, "Reading new directory...");
        display_cwd();
        refresh_cwin();
        new_dir((entries + fl_first + cursor_pos)->e_name, curfilter);
    }
    if(x == 010) {
        x = (entries + (fl_first + cursor_pos))->e_stat.st_mode;
        if(((x & 07777) & 06111)) {
            sprintf(cmd, "Execute \"%s\" (y/n)? ",
                    (entries + (fl_first + cursor_pos))->e_name);
            if(ask_user(cmd, 'n')) {
                sprintf(cmd, "Arguments to '%s'?",
                        (entries + (fl_first + cursor_pos))->e_name);
                args[0] = '\0';
                get_user_input(cmd, args);
                sprintf(cmd, "./%s %s",
                   (entries + (fl_first + cursor_pos))->e_name,
                   (args) ? args : "");
                end_screen();
                my_system(cmd, PAUSE);
                num_marked = 0;
                start_win();
            } else {
                /*
                 * If the user doesn't want to run an executable file
                 * perhaps its a shell script, so lets view it.
                 */
                view_file((entries + fl_first + cursor_pos)->e_name);
            }
        } else {
            view_file((entries + fl_first + cursor_pos)->e_name);
        }
        new_dir(".", curfilter);
    }
    return(RCNOERR);
}
