/*
 * struct.h - contains definition of entry structure.
 *
 * $Source: /u/pfratar/src/files-2.1/src/RCS/struct.h,v $
 *
 * files - full screen file manager for UNIX
 * Copyright (C) 1993 Paul Frattaroli
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

/*
 * structure to hold a single directory entry.
 */
typedef struct entry {
    char *e_name;
    char *e_flstr;
    struct stat e_stat;
    u_long e_flags;
} entry;

/*
 * structure to hold all the necessary info needed to return to a
 * directory that has already been read.
 */
typedef struct dirst {
    char *d_name;
    int d_sort_type;
    int d_count;
    int d_fl_first;
    int d_fl_last;
    int d_cursor_pos;
    int d_num_marked;
    int *d_marked_list;
    int d_kw_mode;
    u_long d_mrk_sum;
    struct stat *d_stat;
    struct entry *d_entries;
    u_long d_flags;
} dirst;

typedef struct conf_t {
    char ct_name[32];
    char ct_desc[64];
    int ct_val;
    int ct_ny;
    int ct_nx;
    int ct_dy;
    int ct_dx;
} conf_t;

